#ifndef TRACEFUNCTION_HPP
#define TRACEFUNCTION_HPP


/**
  \brief Helper class to automatically log enter and leave events

*/
#include "TraceModule.h"

namespace NTracer
{

class TraceFunction
{
public:
  TraceFunction(CTraceModule *trace_module, const char *funcname);
  ~TraceFunction();

  void operator ()();
  void operator ()(const char *fmt, ...);

private:
  bool m_logged;
  CTraceModule *m_trace_module;
  QString m_function_name;
};

} // namespace

#endif
